1 rem
9 REM ------------------------------------------------------------
10 REM
11    RBUF$ = SPACE$(132) : PBUF$ = SPACE$(132)
12    OBUF$ = SPACE$(132)
13    JUNK$ = SPACE$(132)
14    ICH$ = SPACE$(1)
15    ACK$ = SPACE$(1)
16    CR$ = CHR$(13) 
17    comment$ = space$(132)
18    MINHARDWAREFREQ# = 1#
20    debug =0
30    ON ERROR GOTO 16900
100 REM ------------------------------------------------------------
110  REM GW-BASIC Example Program
120  REM
130  REM This is a sample program intended for reference only.
140 REM ------------------------------------------------------------
150 REM
160 REM Test Program for Programmer's Commands
170 REM RS-232 version.
180 REM
190 REM ------------------------------------------------------------
200 REM ------------------------------------------------------------
210 REM ------------------------------------------------------------
220    PRINT "Begin RS-232 Communications Setup"
230 REM ------------------------------------------------------------
240 REM     Open Com Port 2
250 REM 4800 baud, no parity, 8 bits, 1 stop, suppress Request to Send
260 REM
270    OPEN "com2:4800,N,8,1,RS,DS0" FOR RANDOM AS #2
272    LOOPit = 0
274    DELAY = .5: GOSUB 6900        'Wait a little'
280 REM ..
290 REM     Flush anything in input buffer
310    WHILE (LOC(2) > 0)
320      JUNK$ = INPUT$(1, #2): SOUND 2000, 1
330    WEND
430 REM
440 REM     Begin Autobaud Sequence
450 REM ..                             'Send <SP>'
460    PRINT #2, " "; : SOUND 400, 1
470    DELAY = .5: GOSUB 6900      'Wait a little'
480    IF (LOC(2) > 0) THEN 510 ELSE 490
490 REM ..
500    GOTO 450                       'No Response. Try Again'
510    ICH$ = INPUT$(1, #2): SOUND 1000, 1
515    LOOPit = LOOPit + 1
520    PRINT "Received ", ICH$
530    IF (ICH$ = "*") GOTO 590       'Autobaud ACK O.K.'
540 REM
550 REM  If already autobauded, take appropriate action.
560    IF (ICH$ = "B") GOTO 690       'BOOT Program ACK O.K.'
562    IF (ICH$ = "F") GOTO 760       'MAIN Program ACK O.K.'
564 REM
565    WHILE (LOC(2) > 0)              'Flush input'
566      JUNK$ = INPUT$(1, #2): SOUND 2000, 1
567    WEND
568 REM
569    IF ( LOOPit < 3 ) GOTO 280        'Bad Response. Try Again'
570 rem
575 REM  May be we have already autobauded; these commands will put us in
576 REM   a known state without restarting the instrument.
577    PRINT #2, CHR$(248);    'Send UTIL SET INTELLIGENT Pseudo Commnad'
578    PRINT #2, CHR$(222);    'Send UTIL REBOOT if Hung'
580    GOTO 280                        'Keep on Trying
590 REM ..
600    DELAY = .5: GOSUB 6900          'Wait a little'
610    INPUT #2, BOOTMSG$              'Flush out Boot Message'
620    PRINT BOOTMSG$
630 REM
640    PRINT #2, CHR$(247);            'Send UTIL STARTUP INTELLIGENT MODE'
650 REM
660    ICH$ = INPUT$(1, #2)            'ACK of UTIL STARTUP INTELLIGENT MODE'
670    IF (ICH$ <> "=") GOTO 272       'Bad ACK. Try Again'
680 REM
690 REM ..    Jump to Main Program
700    PRINT "Jump to Main Program"
710    PRINT #2, "O";                  'Send UTIL START MAIN PROGRAM'
720    PRINT #2, "2000"; : PRINT #2, CHR$(0);
730 REM
740    WHILE (INPUT$(1, #2) <> "*")    'Wait for Main Program Response'
750    WEND
760 REM ..
770    SOUND 500, 4: SOUND 1000, 4: SOUND 500, 4
780    PRINT "RS-232 Communications Established"
790   PRINT #2, "y";                  'NO comma or <CR> after command'
800   GOSUB 6200     'Wait For Confirmation'
810 REM
820   INPUT #2, VERNO$
830   PRINT "BOOT Version:", VERNO$
840 REM
850   PRINT #2, "z";
860   GOSUB 6200     'Wait For Confirmation'
870   INPUT #2, VERNO$
880   PRINT "MAIN Version:", VERNO$
5700 REM
5708 REM Only INIT on 1st time power up
5710 IF (ICH$ = "F") GOTO 5950       'We started up in MAIN program
5720 rem
5750 REM ----- Send Mono Init Command
5760  PRINT "Init Mono, Please Wait..."
5762  rem   Allow for long init of 220M, 270M
5800  ICH$ = "A"
5900  GOSUB 14500     'Put ICH$ to RS-232 and wait for confirm 
5910  PRINT "Mono Init Done"
5950 PRINT " " : PRINT " " :  PRINT "Hit any key:"
6000 WHILE (INKEY$ = "") : WEND
6050 rem
6100 GOTO 16600  '*** Jump To User Interface
6150 REM___________________________________________________________________
6200 REM ***** Input ACK ****  and test for valid
6205  if (debug = 1) then print "wait for ACK"
6210   ACK$ = INPUT$(1, #2): IF (SAYOK = 1) THEN SOUND 1000, 2
6220   IF (ACK$ = "o") THEN 6230 ELSE 6260
6230   REM ..
6240   IF (SAYOK = 1) THEN PRINT "Receive was O.K."
6250   GOTO 6300
6260 REM ..
6270   IF (ACK$ = "b") THEN PRINT "Receive was bad"
6280   PRINT "Character Received was: "; ASC(ACK$), ACK$
6290   STOP
6300 REM ..
6310   return
6900 REM___________________________________________________________________
6950 REM ***** Time Delay of delay *****
7000   T0 = TIMER
7050   WHILE ((TIMER - T0) < DELAY)
7100   WEND
7150   RETURN
7200 REM___________________________________________________________________
9700 REM___________________________________________________________________
9750 REM ***** Short Move to target and display position until done *****
9800  GOSUB 11650           'Move Relative
9850 WHILE ( MOTORBUSY = 1 )
9900    GOSUB 17100        'Get and Display Position
9950    GOSUB 12250        'Test Motor Busy
10000  WEND
10050  GOSUB 17100        'Get and Display Position
10100  RETURN
10150 REM___________________________________________________________________
10200 REM ***** Backlash Move to target and display position until done *****
10250  IF ( TARGET# > STEPS# ) THEN GOTO 10450
10300  TMP# = TARGET# : TARGET# = TMP# - BACKLASH# : GOSUB 10600
10350  IF (HALTSCAN = 1) THEN RETURN
10400  TARGET# = TMP#
10450 REM ...
10500  GOSUB 10600
10550  RETURN
10600 REM___________________________________________________________________
10650 REM ***** Move to target and display position until done *****
10700  GOSUB 11650           'Move Relative
10750  HALTSCAN = 0
10800  WHILE ( MOTORBUSY = 1 )
10850    GOSUB 26050         'GetKey
10900    IF (KEYVALUE = 0) THEN GOTO 11350                   'no key
10950    IF (KEYVALUE = F6KV) THEN GOSUB 30650 : GOTO 11350  'shutter
11000    IF (KEYVALUE = F8KV) THEN 11050 ELSE 11250      'halt
11050 REM ... 'STOP SCAN
11100     GOSUB 12000    'stop motor
11150     HALTSCAN = 1  'flag to others than scan was halted
11200     GOTO 11350
11250  REM ... invalid key during scan
11300    SOUND 500,1
11350  REM ...
11400    GOSUB 17100        'Get and Display Position
11450    GOSUB 12250        'Test Motor Busy
11500  WEND
11550  GOSUB 17100        'Get and Display Position
11600  RETURN
11650 REM___________________________________________________________________
11700 REM ***** Motor Move Relative in Steps *****
11750   RELSTEPS# = TARGET# - STEPS#
11800   OBUF$ = "F" + "0" + "," + STR$(RELSTEPS#) + CR$
11850   GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
11900   MOTORBUSY = 1
11950   RETURN
12000 REM___________________________________________________________________
12050 REM ***** Motor Stop *****
12100   ICH$ = "L" 
12150   GOSUB 14500     'Put ICH$ to RS-232 and wait for confirm 
12200   RETURN
12250 REM___________________________________________________________________
12300 REM ***** Motor Busy *****
12350   ICH$ = "E" 
12400   GOSUB 14500     'Put ICH$ to RS-232 and wait for confirm
12450 REM
12460   ACK$ = INPUT$(1, #2)
12650   IF (ACK$ = "q") THEN 12700 ELSE 12750
12700   MOTORBUSY = 1 : GOTO 12800
12750   MOTORBUSY = 0 : GOTO 12800
12800 REM ...
12850   RETURN
12860 REM___________________________________________________________________
12861 REM ***** Motor Status *****
12862   ICH$ = "K" 
12863   GOSUB 14500     'Put ICH$ to RS-232 and wait for confirm
12864   rem
12865   GOSUB 14250     'Get RBUF$ from RS-232
12866   limit = val(rbuf$)
12870   return
12900 REM _______________________________________________________
12950 REM ***** Motor Set Position *****
13000   STEPS# = WAVE# * STEPSPERUNIT#
13050   OBUF$ = "G0," + STR$(STEPS#) + CR$
13100   GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
13150   RETURN
13200 REM _______________________________________________________
13250 REM ***** Motor Read Position
13300   OBUF$ = "H0" + CR$
13350   GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
13400   REM
13450   GOSUB 14250     'Get RBUF$ from RS-232
13500   PBUF$ = RBUF$
13550   STEPS# = VAL(PBUF$) : WAVE# = STEPS# / STEPSPERUNIT#
13600   RETURN
13650 REM___________________________________________________________________
13700 REM ***** Motor Set Speed
13750   FREQMIN$ = STR$(F1#) : FREQMAX$ = STR$(F2#) : RAMPTIME$ = STR$(RT#)
13800   OBUF$ = "B"+"0,"+ FREQMIN$ +","+ FREQMAX$ +","+ RAMPTIME$ + CR$
13850   GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
13900   RETURN
13950 REM___________________________________________________________________
14000 REM ***** Put OBUF$ to RS-232 ***** and wait for confirm
14010  if (debug = 1) then print "Send OBUF$=",obuf$
14050  print #2,OBUF$;
14150  GOSUB 6200     'Wait For Confirmation'
14200  RETURN
14250 REM___________________________________________________________________
14300 REM ***** Get RBUF$ from RS-232 *****
14310  if (debug = 1) then print "Wait for RBUF$"
14350  input #2,RBUF$
14360  if (debug = 1) then print "Received RBUF$=",obuf$
14450  RETURN
14500 REM___________________________________________________________________
14550 REM ***** Put ICH$ to RS-232 ***** and wait for confirm
14560  if (debug = 1) then print "Send ICH$=",ich$
14600  print #2,ICH$;
14700  GOSUB 6200     'Wait For Confirmation'
14750  RETURN
14800 REM___________________________________________________________________
14850 REM ***** Accessory Busy *****
14900  ICH$ = "l" : GOSUB 14500 'Put ICH$ to RS-232 and confirm
14950  REM
15000   ACK$ = INPUT$(1, #2)
15100  IF (ACK$ = "q") THEN ACCESSORYBUSY = 1 ELSE ACCESSORYBUSY = 0
15150  RETURN
15200 REM___________________________________________________________________
15250 REM___________________________________________________________________
15300 REM *** SHUTTER_OPEN  else SHUTTER_CLOSE ***
15350  IF ( SHUTTER = 1) THEN OBUF$ = "W0" + CR$ ELSE OBUF$ = "X0" + CR$
15400  GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
15450  GOSUB 19050     'Display Shutter Position
15452  ACCESSORYBUSY = 1
15500  RETURN
15550 REM___________________________________________________________________
15600 REM *** TURRET_POSITION_1  else  TURRET_POSITION_0 ***
15650  IF ( TURRET = 1) THEN OBUF$ = "a0" + CR$ ELSE OBUF$ = "b0" + CR$
15700  GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
15750  GOSUB 18600      'Display Accessories
15752  ACCESSORYBUSY = 1
15800  RETURN
15850 REM___________________________________________________________________
15900 REM *** ENTR_MIRROR_SIDE_POSITION  else  ENTR_MIRROR_FRONT_POSITION ***
15950  IF ( ENTMIRROR = 1) THEN OBUF$ = "c0" + CR$ ELSE OBUF$ = "d0" + CR$
16000  GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
16050  GOSUB 18600      'Display Accessories
16052  ACCESSORYBUSY = 1
16100  RETURN
16150 REM___________________________________________________________________
16200 REM *** EXIT_MIRROR_SIDE_POSITION  else  EXIT_MIRROR_FRONT_POSITION ***
16250  IF ( EXTMIRROR = 1) THEN OBUF$ = "e0" + CR$ ELSE OBUF$ = "f0" + CR$
16300  GOSUB 13950     'Put OBUF$ to RS-232 and wait for confirm
16350  GOSUB 18600      'Display Accessories
16352  ACCESSORYBUSY = 1
16400  RETURN
16450 REM___________________________________________________________________
16500 REM
16550 REM ------------------------------------------------------------
16600    ON ERROR GOTO 16900
16650 REM ------------------------------------------------------------
16700 REM ...
16750   GOSUB 36350        'Input Last Set of User Parameters
16800   GOTO 19350          'Jump To Main
16850 REM___________________________________________________________________
16900 REM .....Error Handler
16950   PRINT "***** Error =", ERR, " on line number", ERL
17000   LASTERROR = ERR
17050   rem IF (LASTERROR = 62) THEN RESUME NEXT ELSE STOP
17060   resume next
17100 REM___________________________________________________________________
17150 REM ***** Get and Display Position *****
17200  GOSUB 13200      'Read Mono Position
17210  gosub 12860      'Check limits
17250  LOCATE 1, 40
17300  PRINT USING ": #####.###  ########  ##"; WAVE#, STEPS#, limit
17350  RETURN
17400 REM___________________________________________________________________
17450 REM ***** Display Scan *****
17500  LOCATE 3, 40
17550  PRINT USING ": #####.###"; STARTSCAN#
17600  LOCATE 4, 40
17650  PRINT USING ": #####.###"; ENDSCAN#
17700  LOCATE 5, 40
17750  PRINT USING ": #####.###    ######"; SCANSPEED#, SCANFREQ#
17800  RETURN
17850 REM___________________________________________________________________
17900 REM ***** Display Tweak Speed *****
17950  LOCATE 13, 40
18000  IF (TWEAKSPEED <> 1) THEN PRINT ":  Fast Increment"
18050  IF (TWEAKSPEED = 1) THEN PRINT ":  Slow Increment"
18100  RETURN
18150 REM___________________________________________________________________
18200 REM ***** Markers *****
18250  LOCATE 16, 10
18300  PRINT USING ": #####.###"; MARKERA#
18350  LOCATE 17, 10
18400  PRINT USING ": #####.###"; MARKERB#
18450  LOCATE 18, 10
18500  PRINT USING ": #####.###"; MARKERC#
18550  RETURN
18600 REM___________________________________________________________________
18650 REM ***** Display Accessories *****
18700  LOCATE 8, 40
18750  PRINT ": ", TURRET
18800  LOCATE 9, 40
18850  PRINT ": ", ENTMIRROR
18900  LOCATE 10, 40
18950  PRINT ": ", EXTMIRROR
19000  RETURN
19050 REM___________________________________________________________________
19100 REM ***** Display Shutter *****
19150  LOCATE 7, 40
19200  IF (SHUTTER = 0) THEN PRINT ":  CLOSED" ELSE PRINT ":  OPEN  "
19250  RETURN
19300 REM___________________________________________________________________
19350 REM___________________________________________________________________
19400 REM ***** Main *****
19450  F1KV = 187
19500  F2KV = 188
19550  F3KV = 189
19600  F4KV = 190
19650  F5KV = 191
19700  F6KV = 192
19750  F7KV = 193
19800  F8KV = 194
19850  F9KV = 195
19900  F10KV = 196
19950  LEFTKV = 203
20000  RIGHTKV =205
20050  TKV =  84
20100  EKV =  69
20150  XKV =  88
20200  CTRLA = 1
20250  CTRLB = 2
20300  CTRLC = 3
20350 REM
20400  ON KEY (1) GOSUB 21050
20450  ON KEY (2) GOSUB 21100
20500  ON KEY (3) GOSUB 21150
20550  ON KEY (4) GOSUB 21200
20600  ON KEY (5) GOSUB 21250
20650  ON KEY (6) GOSUB 21300
20700  ON KEY (7) GOSUB 21350
20750  ON KEY (8) GOSUB 21400
20800  ON KEY (9) GOSUB 21450
20850  ON KEY (10) GOSUB 21500
20900  ON KEY (12) GOSUB 21550
20950  ON KEY (13) GOSUB 21600
21000  GOTO 21700
21050  HOTKEY = F1KV : RETURN
21100  HOTKEY = F2KV : RETURN
21150  HOTKEY = F3KV : RETURN
21200  HOTKEY = F4KV : RETURN
21250  HOTKEY = F5KV : RETURN
21300  HOTKEY = F6KV : RETURN
21350  HOTKEY = F7KV : RETURN
21400  HOTKEY = F8KV : RETURN
21450  HOTKEY = F9KV : RETURN
21500  HOTKEY = F10KV : RETURN
21550  HOTKEY = LEFTKV : RETURN
21600  HOTKEY = RIGHTKV : RETURN
21650 REM
21700  KEY(1) ON: KEY(2) ON: KEY(3) ON: KEY(4) ON: KEY(5) ON
21750  KEY(6) ON: KEY(7) ON: KEY(8) ON: KEY(9) ON: KEY(10) ON
21800  KEY(12) ON: KEY(13) ON
21850 REM
21900  GOTO 22100
21950  CLS
22000  LOCATE 15, 20
22050  INPUT "Mono Type: ", MONOWANTED
22100  GOSUB 26700           'Get Mono Type and Parameters
22150  PRINT " ": PRINT "Hit any key:"
22200  WHILE (INKEY$ = "") : WEND
22250 REM
22300  CLS
22350 REM
22400  SAYOK = 0	    'TURN OFF RS-232 ACK sound and OK print out flag
22450  MOTORBUSY = 0 : MOVEBUSY = 0 : HALTSCAN = 0 
22452  ACCESSORYBUSY = 0 : tupdate = timer
22500  WAVE# = 0# : TARGET# = 0#
22550  TWEAKINC = 1
22600  TWEAKSPEED = 1 : TWEAKMAX = STEPSPERUNIT# + 1
22650  STEPS# = 0#
22700  SHUTTER = 0
22750  TURRET = 0
22800  ENTMIRROR = 0
22850  EXTMIRROR = 0
22900  SCANSPEED# = SCANFREQ# / STEPSPERUNIT#
22950 REM
23000  MENUROW = 1 : MENUCOL = 15 : GOSUB 25000      'Put up Main Menu
23050  ROW = 20 : COL = 20 : MESSAGE$ = "Command: " : GOSUB 28100
23100  ROW = 20 : COL = 20+9
23150 REM
23200  GOSUB 30150      'Calibrate
23250  GOSUB 17100       'Display Position
23300  GOSUB 17400       'Display Scan
23350  GOSUB 17850       'Display Tweak Speed
23400  GOSUB 18600       'Display Accessories
23450  GOSUB 15250       'Do and Display Shutter
23500  GOSUB 18150       'Display Markers
23550  F1# = MINFREQ# : F2# = MAXFREQ# : RT# = RAMPTIME#
23600  GOSUB 13650       'Set Motor Speed
23650 REM
23700 WHILE (1)
23750   GOSUB 26050         'GetKey
23800   IF (KEYVALUE = 0) THEN GOTO 24850
23850   IF (KEYVALUE = 19) THEN GOTO 21950   '(Ctrl-S) Change Mono Type
23900   IF (KEYVALUE = F1KV) THEN GOSUB 28350 : GOTO 24850
23950   IF (KEYVALUE = F2KV) THEN GOSUB 28800 : GOTO 24850
24000   IF (KEYVALUE = F3KV) THEN GOSUB 29200 : GOTO 24850
24050   IF (KEYVALUE = F4KV) THEN GOSUB 29600 : GOTO 24850
24100   IF (KEYVALUE = F5KV) THEN GOSUB 30150 : GOTO 24850
24150   IF (KEYVALUE = F6KV) THEN GOSUB 30650 : GOTO 24850
24200   IF (KEYVALUE = F7KV) THEN GOSUB 30950 : GOTO 24850
24250   IF (KEYVALUE = F8KV) THEN GOSUB 32550 : GOTO 24850
24300   IF (KEYVALUE = F9KV) THEN GOSUB 32850 : GOTO 24850
24350   IF (KEYVALUE = F10KV) THEN GOSUB 33150 : GOTO 24850
24400   IF (KEYVALUE = LEFTKV) THEN GOSUB 33400 : GOTO 24850
24450   IF (KEYVALUE = RIGHTKV) THEN GOSUB 34100 : GOTO 24850
24500   IF ( (AKEY$ = "T") OR (AKEY$ = "t") ) THEN GOSUB 34750 : GOTO 24850
24550   IF ( (AKEY$ = "E") OR (AKEY$ = "e") ) THEN GOSUB 35050 : GOTO 24850
24600   IF ( (AKEY$ = "X") OR (AKEY$ = "x") ) THEN GOSUB 35350 : GOTO 24850
24650   IF ( (AKEY$ = "A") OR (AKEY$ = "a") ) THEN GOSUB 35650 : GOTO 24850
24700   IF (KEYVALUE = CTRLA) THEN GOSUB 35950 : GOTO 24850
24701   IF ( (AKEY$ = "B") OR (AKEY$ = "b") ) THEN GOSUB 36310 : GOTO 24850
24702   IF (KEYVALUE = CTRLB) THEN GOSUB 36316 : GOTO 24850
24703   IF ( (AKEY$ = "C") OR (AKEY$ = "c") ) THEN GOSUB 36330 : GOTO 24850
24704   IF (KEYVALUE = CTRLC) THEN GOSUB 36336 : GOTO 24850
24750   LOCATE 23,1 : PRINT "Key Value: ",KEYVALUE : SOUND 1000,1
24800   IF (KEYVALUE = 26 ) THEN STOP
24850   REM ...
24852   if ( timer - tupdate < 0.2 ) then goto 24890
24853    tupdate = timer
24854     gosub 17100     'Update position and limits
24856     gosub 14800     'Test accessory busy
24858     if (ACCESSORYBUSY = 1) then LOCATE 23,20 :  Print "Accessory Busy"
24860     if (ACCESSORYBUSY = 0) then  LOCATE 23,1 : PRINT SPACE$(70)
24890   rem ...
24900 WEND
24950 STOP
25000 REM___________________________________________________________________
25050 REM___________________________________________________________________
25100 REM ***** Main Menu *****
25150  LOCATE MENUROW+0,MENUCOL: PRINT "<- Arrow -> to Tweak Mono"
25200  LOCATE MENUROW+1,MENUCOL: PRINT "F1  - Set"
25250  LOCATE MENUROW+2,MENUCOL: PRINT "F2  - Start Position"
25300  LOCATE MENUROW+3,MENUCOL: PRINT "F3  - End Position"
25350  LOCATE MENUROW+4,MENUCOL: PRINT "F4  - Scan Speed"
25400  LOCATE MENUROW+5,MENUCOL: PRINT "F5  - Calibrate"
25450  LOCATE MENUROW+6,MENUCOL: PRINT "F6  - Shutter"
25500  LOCATE MENUROW+7,MENUCOL: PRINT " T   - Turret"
25550  LOCATE MENUROW+8,MENUCOL: PRINT " E   - Entrance Mirror"
25600  LOCATE MENUROW+9,MENUCOL: PRINT " X   - Exit Mirror"
25650  LOCATE MENUROW+10,MENUCOL: PRINT "F7 - Scan"
25700  LOCATE MENUROW+11,MENUCOL: PRINT "F8 - HALT"
25750  LOCATE MENUROW+12,MENUCOL: PRINT "F9 - Tweak Speed"
25800  LOCATE MENUROW+13,MENUCOL: PRINT "F10 - EXIT"
25850  LOCATE MENUROW+15,1 : PRINT "Marker A"
25900  LOCATE MENUROW+16,1 : PRINT "Marker B"
25950  LOCATE MENUROW+17,1 : PRINT "Marker C"
26000  RETURN
26050 REM___________________________________________________________________
26100 REM ***** GetKey *****
26150  IF ( HOTKEY = 0 ) THEN GOTO 26350
26200  KEYVALUE = HOTKEY : HOTKEY = 0
26250  RETURN
26300 REM
26350  AKEY$ = INKEY$
26400  L = LEN(AKEY$)+1
26450  ON L GOTO 26500,26550,26600
26500  KEYVALUE = 0 : GOTO 26650
26550  KEYVALUE = ASC(AKEY$) : GOTO 26650
26600  KEYVALUE = ASC(MID$(AKEY$, 2)) + 128 : GOTO 26650
26650  RETURN
26700 REM___________________________________________________________________
26750 REM ***** Read Mono Parameter File *****
26800  OPEN "232_scan.ini" FOR INPUT AS #3
26850  NRECSKIP = 7 : LASTERROR = 0
26900  REM ...
26950  INPUT #3, MONOTYPE, COMMENT$: PRINT MONOTYPE, COMMENT$
27000  IF (LASTERROR <> 62) THEN 27200
27050    CLOSE #3
27100    PRINT "Parameters for Mono Type ",MONOWANTED," NOT found."
27150    GOTO 22000
27200  REM ...
27250  IF (MONOTYPE = MONOWANTED) THEN 27300 ELSE 27700
27300     INPUT #3, STEPSPERUNIT#, COMMENT$: PRINT STEPSPERUNIT#, COMMENT$
27350     INPUT #3, MINFREQ#, COMMENT$: PRINT MINFREQ#, COMMENT$
27400     INPUT #3, MAXFREQ#, COMMENT$: PRINT MAXFREQ#, COMMENT$
27450     INPUT #3, RAMPTIME#, COMMENT$: PRINT RAMPTIME#, COMMENT$
27500     INPUT #3, BACKLASH#, COMMENT$: PRINT BACKLASH#, COMMENT$
27550     INPUT #3, BASEGRATE#, COMMENT$: PRINT BASEGRATE#, COMMENT$
27600     INPUT #3, COMMENT$: PRINT COMMENT$
27650   GOTO 27950
27700      FOR I = 1 TO NRECSKIP
27750        INPUT #3, COMMENT$
27800      NEXT I
27850      PRINT COMMENT$
27900   GOTO 26900
27950 REM ...
28000  CLOSE #3
28050  RETURN                                           
28100 REM___________________________________________________________________
28150 REM ***** Print Message *****
28200  LOCATE ROW,COL : PRINT SPACE$(50) : LOCATE ROW,COL
28250  PRINT MESSAGE$
28300  RETURN
28350 REM___________________________________________________________________
28400 REM *****  F1  *****
28450  MESSAGE$ = "F1" : GOSUB 28100
28500  LOCATE 22,20
28550  INPUT "Move to: ", W#
28600  TARGET# = W# * STEPSPERUNIT#
28650  LOCATE 22,1 : PRINT SPACE$(70)
28700  GOSUB 10150        'Move to target, display and wait till done
28750  RETURN
28800 REM___________________________________________________________________
28850 REM *****  F2  *****
28900  MESSAGE$ = "F2" : GOSUB 28100
28950  LOCATE 22,20
29000  INPUT "Start of Scan: ", STARTSCAN#
29050  LOCATE 22,1 : PRINT SPACE$(70)
29100  GOSUB 17400	       'DisplayScan
29150  RETURN
29200 REM___________________________________________________________________
29250 REM *****  F3  *****
29300  MESSAGE$ = "F3" : GOSUB 28100
29350  LOCATE 22,20
29400  INPUT "End of Scan: ", ENDSCAN#
29450  LOCATE 22,1 : PRINT SPACE$(70)
29500  GOSUB 17400	       'DisplayScan
29550  RETURN
29600 REM___________________________________________________________________
29650 REM *****  F4  *****
29700  MESSAGE$ = "F4" : GOSUB 28100
29750  LOCATE 22,20
29800  INPUT "Scan Speed: ", SCANSPEED#
29850  LOCATE 22,1 : PRINT SPACE$(70)
29900  SCANFREQ# = SCANSPEED# * STEPSPERUNIT#
29950  IF ( SCANFREQ# <= MAXFREQ# ) THEN GOTO 29960
29952  SCANFREQ# = MAXFREQ# : SCANSPEED# = SCANFREQ# / STEPSPERUNIT#
29954  GOSUB 17400 :  SOUND 500,1 : GOTO 29600
29956 REM
29960  IF ( SCANFREQ# >= MINHARDWAREFREQ# ) THEN GOTO 30000
29962  SCANFREQ# = MINHARDWAREFREQ# : SCANSPEED# = SCANFREQ# / STEPSPERUNIT#
29964  GOSUB 17400 : SOUND 500,1 : GOTO 29600
30000 REM ...
30050  GOSUB 17400	       'DisplayScan
30100  RETURN
30150 REM___________________________________________________________________
30200 REM *****  F5  *****
30250  MESSAGE$ = "F5" : GOSUB 28100
30300  LOCATE 22,20
30350  INPUT "Where are you: ", WAVE#
30400  LOCATE 22,1 : PRINT SPACE$(70)
30450 REM
30500  GOSUB 12900       'Set Mono Position
30550  GOSUB 17100       'Display Position
30600  RETURN
30650 REM___________________________________________________________________
30700 REM *****  F6  *****
30750  MESSAGE$ = "F6" : GOSUB 28100
30800  SHUTTER = 1 - SHUTTER
30850  GOSUB 15250
30900  RETURN
30950 REM___________________________________________________________________
31000 REM *****  F7  *****
31050  MESSAGE$ = "F7" : GOSUB 28100
31100 REM
31150  LOCATE 11, 40
31200  PRINT ":  Positioning"
31250  HALTSCAN = 0
31300  TARGET# = STARTSCAN# * STEPSPERUNIT#
31350  GOSUB 10150         'Move to target, display and wait till done
31400 REM
31450  IF ( HALTSCAN = 1 ) THEN GOTO 32150      'User halt
31500 REM
31550  DELAY = 1! : GOSUB 6950       'Delay before Start
31600  LOCATE 11, 40
31650  PRINT ":  STARTED     "
31700  TARGET# = ENDSCAN# * STEPSPERUNIT#
31750 REM Load Scan Speed
31800  F1# = MINFREQ# :  F2# = SCANFREQ# : RT# = RAMPTIME#
31850  IF ( SCANFREQ# < MINFREQ# ) THEN F1# = SCANFREQ#
31900  GOSUB 13650       'Set Motor Speed
31950 REM
32000  GOSUB 10150        'Move to target, display and wait till done
32050 REM
32100  GOSUB 32550       'Stop Scan and re-enable Hot Keys
32150 REM ...
32200  HALTSCAN = 0
32250  LOCATE 11, 40
32300  PRINT ":  STOPPED     "
32350 REM Load Normal Speed
32400  F1# = MINFREQ# : F2# = MAXFREQ# : RT# = RAMPTIME#
32450  GOSUB 13650       'Set Motor Speed
32500  RETURN
32550 REM___________________________________________________________________
32600 REM *****  F8  *****
32650  MESSAGE$ = "F8" : GOSUB 28100
32700  HALTSCAN = 1
32750  WHILE ( INKEY$ <> "" ) : WEND  'Flush input buffer
32800  RETURN
32850 REM___________________________________________________________________
32900 REM *****  F9  *****
32950  MESSAGE$ = "F9" : GOSUB 28100
33000  TWEAKSPEED = TWEAKMAX - TWEAKSPEED
33050  GOSUB 17850           'DisplayTweakSpeed
33100  RETURN
33150 REM___________________________________________________________________
33200 REM *****  F10  *****
33250  MESSAGE$ = "F10" : GOSUB 28100
33300  GOSUB 36950      'Shut dowm
33350  RETURN
33400 REM___________________________________________________________________
33450 REM *****  Left Arrow  *****
33500  MESSAGE$ = "Left" : GOSUB 28100
33550  IF ( TWEAKSPEED <> 1 ) THEN 33650
33600  IF ( (TIMER-T1) > .2 ) THEN 33650 ELSE 33700
33650  F = 1 : GOTO 33750
33700  F = F + 3 : IF ( F > 5*TWEAKMAX ) THEN F = 5*TWEAKMAX
33750  TARGET# = (STEPS# - TWEAKINC * TWEAKSPEED * F)
33800  IF (TARGET# < 0#) THEN TARGET# = 0# : SOUND 1000,1
33850 REM
33900  GOSUB 9700        'Short Move to target, display and wait till done
33950  T1 = TIMER
34050  RETURN
34100 REM___________________________________________________________________
34150 REM *****  Right Arrow  *****
34200  MESSAGE$ = "Right" : GOSUB 28100
34250  IF ( TWEAKSPEED <> 1 ) THEN 34350
34300  IF ( (TIMER-T2) > .2 ) THEN 34350 ELSE 34400
34350  F = 1 : GOTO 34450
34400  F = F + 3 : IF ( F > 5*TWEAKMAX ) THEN F = 5*TWEAKMAX
34450  TARGET# = (STEPS# + TWEAKINC * TWEAKSPEED * F)
34500 REM
34550  GOSUB 9700        'Short Move to target, display and wait till done
34600  T2 = TIMER
34700  RETURN
34750 REM___________________________________________________________________
34800 REM ***** "T" Turret  *****
34850  MESSAGE$ = "T" : GOSUB 28100
34900  TURRET = 1 - TURRET
34950  GOSUB 15550       'Do Turret and Display Accessories
35000  RETURN
35050 REM___________________________________________________________________
35100 REM ***** "E" ENTmirror  *****
35150  MESSAGE$ = "E" : GOSUB 28100
35200  ENTMIRROR = 1 - ENTMIRROR
35250  GOSUB 15850       'Do Entrance Mirror and Display Accessories
35300  RETURN
35350 REM___________________________________________________________________
35400 REM ***** "X" EXTmirror  *****
35450  MESSAGE$ = "X" : GOSUB 28100
35500  EXTMIRROR = 1 - EXTMIRROR
35550  GOSUB 16150       'Do Exit Mirror and Display Accessories
35600  RETURN
35650 REM___________________________________________________________________
35700 REM ***** "A" go to marker A *****
35750  MESSAGE$ = "Go to A" : GOSUB 28100
35800  TARGET# = MARKERA# * STEPSPERUNIT#
35850  GOSUB 10150        'Move to target, display and wait till done
35900  RETURN
35950 REM___________________________________________________________________
36000 REM ***** "Ctrl-A" Set marker A *****
36050 MESSAGE$ = "Set A" : GOSUB 28100
36100  LOCATE 22,20
36150  INPUT "Marker A: ", MARKERA#
36200  LOCATE 22,1 : PRINT SPACE$(70)
36250  GOSUB 18150        'Display Markers
36300  RETURN
36310 REM___________________________________________________________________
36311 REM ***** "B" go to marker B *****
36312  MESSAGE$ = "Go to B" : GOSUB 28100
36313  TARGET# = MARKERB# * STEPSPERUNIT#
36314  GOSUB 10150        'Move to target, display and wait till done
36315  RETURN
36316 REM___________________________________________________________________
36317 REM ***** "Ctrl-B" Set marker B *****
36318 MESSAGE$ = "Set B" : GOSUB 28100
36319  LOCATE 22,20
36320  INPUT "Marker B: ", MARKERB#
36321  LOCATE 22,1 : PRINT SPACE$(70)
36322  GOSUB 18150        'Display Markers
36323  RETURN
36330 REM___________________________________________________________________
36331 REM ***** "C" go to marker C *****
36332  MESSAGE$ = "Go to C" : GOSUB 28100
36333  TARGET# = MARKERC# * STEPSPERUNIT#
36334  GOSUB 10150        'Move to target, display and wait till done
36335  RETURN
36336 REM___________________________________________________________________
36337 REM ***** "Ctrl-C" Set marker C *****
36338 MESSAGE$ = "Set C" : GOSUB 28100
36339  LOCATE 22,20
36340  INPUT "Marker C: ", MARKERC#
36341  LOCATE 22,1 : PRINT SPACE$(70)
36342  GOSUB 18150        'Display Markers
36343  RETURN
36350 REM___________________________________________________________________
36400 REM ***** Input User Parameters  *****
36450  OPEN "232_scan.usr" FOR INPUT AS #3
36500  INPUT #3, MONOWANTED, COMMENT$
36550  INPUT #3, STARTSCAN#, COMMENT$
36600  INPUT #3, ENDSCAN#, COMMENT$
36650  INPUT #3, SCANFREQ#, COMMENT$
36700  INPUT #3,MARKERA#, COMMENT$
36750  INPUT #3,MARKERB#, COMMENT$
36800  INPUT #3,MARKERC#, COMMENT$
36850  CLOSE #3
36900  RETURN
36950 REM___________________________________________________________________
37000 REM ***** EXIT  *****
37050 REM Save User Parameters on exit
37100  OPEN "232_scan.usr" FOR OUTPUT AS #3
37150  PRINT #3, MONOTYPE,     " ;Mono Type"
37200  PRINT #3, STARTSCAN#,   " ;Start of Scan"
37250  PRINT #3, ENDSCAN#,     " ;End of Scan"
37300  PRINT #3, SCANFREQ#,    " ;Scan Freq"
37350  PRINT #3,MARKERA#,      " ;Marker A"
37400  PRINT #3,MARKERB#,      " ;Marker B"
37450  PRINT #3,MARKERC#,      " ;Marker C"
37500  CLOSE #3
37550 REM
37600  Close #2                   'Close RS-232 port
37650  SYSTEM                     'Exit BASIC
37700  END
